/**
  *  \file u/t_util_random.cc
  *
  *  (c) 2001-2021 Stefan Reuther <Streu@gmx.de>
  *
  *  This program is free software; you can redistribute it and/or
  *  modify it under the terms of file `COPYING' that comes with the
  *  source code.
  *
  *  This program is distributed in the hope that it will be useful,
  *  but WITHOUT ANY WARRANTY; without even the implied warranty of
  *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
  */

#include "u/t_util.h"
#include "util/random.h"

void
UtilRandomTestsuite::testRandom()
{
    enum {
        N = 100,
        M = 300
    };
    int freqs[N];

    myRandom.setSeed(0);     /* for reproducibility */
    for (int i = 0; i < N; ++i) {
        freqs[i] = 0;
    }
    for (int i = 0; i < N*M; ++i) {
        ++freqs[myRandom(N)];
    }

    for (int i = 0; i < N; ++i) {
        TS_ASSERT_LESS_THAN_EQUALS(freqs[i], M*6/5);
        TS_ASSERT_LESS_THAN_EQUALS(M*4/5, freqs[i]);
    }
}
